<template>
  <div>
    <slot name="deleteAction" :confirm-delete="confirmDelete"></slot>
  </div>
</template>
<script>
import notificationsMixin from '~/mixins/notifications.js';
export default {
  mixins: [notificationsMixin],
  props: {
    id: {
      type: String,
      default: '',
    },
  },
  methods: {
    async confirmDelete() {
      await this.$bvModal
        .msgBoxConfirm('Do you want to delete the project?', {
          id: 'delete-project-modal',
          title: 'Delete project',
          size: 'sm',
          buttonSize: 'sm',
          okVariant: 'danger',
          okTitle: 'Yes',
          cancelTitle: 'No',
          footerClass: 'p-2',
          hideHeaderClose: false,
          centered: true,
        })
        .then(async (value) => {
          if (value) await this.deleteProject();
        });
    },
    async deleteProject() {
      const response = await this.$nuxt.context.store
        .dispatch('projects/deleteProject', {
          projectId: this.id,
        })
        .catch(() => {
          this.showNotification(
            'Ops... The project could not be deleted',
            'Error Deleting Project',
            'danger'
          );
        });
      if (response) {
        this.showNotification(
          'The project was deleted successfully',
          'Project Deleted!'
        );
        this.$nuxt.context.store.dispatch('projects/fetchProjects');
        this.$router.push({
          path: `/projects`,
        });
        this.$store.commit('ui/setSearchWorkspaceVisible', false);
      }
    },
  },
};
</script>
